function WPATH(s) {
    var index = s.lastIndexOf("/");
    var path = -1 === index ? "calendar/" + s : s.substring(0, index) + "/calendar/" + s.substring(index + 1);
    return path;
}

function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    var Widget = new (require("alloy/widget"))("calendar");
    this.__widgetId = "calendar";
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "widget";
    this.args = arguments[0] || {};
    if (arguments[0]) {
        __processArg(arguments[0], "__parentSymbol");
        __processArg(arguments[0], "$model");
        __processArg(arguments[0], "__itemTemplate");
    }
    var $ = this;
    var exports = {};
    $.__views.widget = Ti.UI.createTableView({
        height: Ti.Platform.displayCaps.platformWidth,
        backgroundColor: "#fff",
        separatorColor: "#e2e2e4",
        id: "widget"
    });
    $.__views.widget && $.addTopLevelView($.__views.widget);
    exports.destroy = function() {};
    _.extend($, $.__views);
    var args = arguments[0] || {};
    var data = {
        rows: [],
        start: false,
        end: false,
        first: moment(),
        last: moment().add(20, "days"),
        limit: 20,
        items: {}
    };
    $.widget.width = Ti.Platform.displayCaps.platformHeight - 60;
    if (args.date) {
        data.first = args.date;
        data.last = moment(args.date).add(20, "days");
    }
    $.widget.width = Ti.Platform.displayCaps.platformWidth;
    $.widget.transform = Ti.UI.create2DMatrix().rotate(-90);
    data.click = function(table) {
        null != data.selected && void 0 != data.selected && data.rows[data.selected].select(false);
        data.selected = table.index;
        table.row.select(true);
    };
    for (var i = 0; 20 >= i; i++) {
        var time = moment(data.first).add(i, "days");
        data.rows.push(Widget.createController("row", {
            width: parseInt($.widget.width / 5),
            date: time,
            button: args.button,
            item: data.items[time.format("YYYY-MM-DD")],
            fields: args.fields
        }).getView());
    }
    $.widget.setData(data.rows);
    data.scroll = function() {};
    data.scrollend = function(table) {
        data.start = !parseInt(table.contentOffset.y);
        data.end = parseInt(table.contentOffset.y) == parseInt(parseInt(table.contentSize.height) - parseInt($.widget.width));
        if (data.start || data.end) {
            $.widget.opacity = .5;
            $.widget.touchEnabled = false;
            for (var i = 0; 20 >= i; i++) {
                var time = data[data.start ? "first" : "last"][data.start ? "subtract" : "add"](1, "days");
                data.rows[data.start ? "unshift" : "push"](Widget.createController("row", {
                    width: parseInt($.widget.width / 5),
                    date: time,
                    button: args.button,
                    item: data.items[time.format("YYYY-MM-DD")],
                    fields: args.fields
                }).getView());
            }
            $.widget.setData(data.rows);
            $.widget.scrollToIndex(data.start ? 22 : parseInt(data.rows.length - 19));
            $.widget.opacity = 1;
            $.widget.touchEnabled = true;
        }
    };
    $.widget.addEventListener("click", data.click);
    $.widget.addEventListener("scroll", data.scroll);
    $.widget.addEventListener("scrollend", data.scrollend);
    $.widget.destructor = function() {
        $.destroy();
        $.off();
        $.widget.visible = false;
        for (var i in data.rows) data.rows[i] && data.rows[i].destructor && data.rows[i].destructor();
        $.widget.setData([]);
        $.widget.removeEventListener("click", data.click);
        $.widget.removeEventListener("scroll", data.scroll);
        $.widget.removeEventListener("scrollend", data.scrollend);
        $ = data = args = null;
    };
    _.extend($, exports);
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;