var args = arguments[0] || {};
	
var data = {
	rows:[],
	start:false,
	end:false,
	first:moment(),
	last:moment().add(20,'days'),
	limit:20,
	items:{}
};

$.widget.width = Ti.Platform.displayCaps.platformHeight-60;

if(args.date) {
	
	data.first = args.date;

	data.last = moment(args.date).add(20,'days');
}

$.widget.width = Ti.Platform.displayCaps.platformWidth;

$.widget.transform = Ti.UI.create2DMatrix().rotate(-90);

data.click = function(table) {
	
	if(data.selected != null && data.selected != undefined) data.rows[data.selected].select(false);
	
	data.selected = table.index;
	
	table.row.select(true);
};

for(var i = 0; i <= 20; i++) {
	
	var time = moment(data.first).add(i,'days');
	
	data.rows.push(Widget.createController('row',{
		width:parseInt($.widget.width/5),
		date:time,
		button:args.button,
		item:data.items[time.format('YYYY-MM-DD')],
		fields:args.fields
	}).getView());
}

$.widget.setData(data.rows);

data.scroll = function(table) {
	
	if(OS_ANDROID) {
		
		data.start = !parseInt(table.firstVisibleItem);
	
		data.end = parseInt(table.totalItemCount) == parseInt(parseInt(table.visibleItemCount)+parseInt(table.firstVisibleItem));
	}
};

data.scrollend = function(table) {
	
	if(OS_IOS) {
		
		data.start = !parseInt(table.contentOffset.y);
		
		data.end = parseInt(table.contentOffset.y) == parseInt(parseInt(table.contentSize.height)-parseInt($.widget.width));
	}

	if(data.start || data.end) {

		$.widget.opacity = 0.5;
		
		$.widget.touchEnabled = false;
		
		for(var i = 0; i <= 20; i++) {
			
			var time = data[data.start ? 'first' : 'last'][data.start ? 'subtract' : 'add'](1,'days');
			
			data.rows[data.start ? 'unshift' : 'push'](Widget.createController('row',{
				width:parseInt($.widget.width/5),
				date:time,
				button:args.button,
				item:data.items[time.format('YYYY-MM-DD')],
				fields:args.fields
			}).getView());
		}
			
		$.widget.setData(data.rows);
		
		$.widget.scrollToIndex(data.start ? 22 : parseInt(data.rows.length-19));

		$.widget.opacity = 1;
		
		$.widget.touchEnabled = true;
	}
};

$.widget.addEventListener('click',data.click);

$.widget.addEventListener('scroll',data.scroll);

$.widget.addEventListener('scrollend',data.scrollend);

$.widget.destructor = function() {
	
	$.destroy();
	
	$.off();
	
	$.widget.visible = false;
	
	for(var i in data.rows) if(data.rows[i] && data.rows[i].destructor) data.rows[i].destructor();
	
	$.widget.setData([]);

	$.widget.removeEventListener('click',data.click);
	
	$.widget.removeEventListener('scroll',data.scroll);
	
	$.widget.removeEventListener('scrollend',data.scrollend);

	$ = data = args = null;
};